package com.mentormate.academy.contentproviders;

import android.content.ContentValues;
import android.content.Context;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.net.Uri;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;


public class MainActivity extends ActionBarActivity implements View.OnClickListener {

    EditText date;
    EditText name;
    private  String  usernamaByDefault = "default username";
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        Button btnDelete = (Button) findViewById(R.id.btnDelete);
        Button btnSelect = (Button) findViewById(R.id.btnSelect);
        Button btnInsert = (Button) findViewById(R.id.btnInsert);
        btnDelete.setOnClickListener(this);
        btnSelect.setOnClickListener(this);
        btnInsert.setOnClickListener(this);

        date = (EditText) findViewById(R.id.birthdayInput);
         name= (EditText) findViewById(R.id.nameInput);

        // it's being used for any kind of settings, not important data
        SharedPreferences sharedPreferences = getSharedPreferences("SETTING", Context.MODE_PRIVATE);

        if (sharedPreferences.contains("username")){
            usernamaByDefault = sharedPreferences.getString("username",usernamaByDefault);
        }

        usernamaByDefault = "happy user";

        SharedPreferences.Editor editor = sharedPreferences.edit();
        editor.putString("username",usernamaByDefault);
        editor.commit();

    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.btnDelete:
                int count = getContentResolver().delete(Constants.URI,null,null);
                Log.d("db delete",count + " record were deleted");


                break;
            case R.id.btnInsert:
                    String dateStr = date.getText().toString();
                  String nameStr = name.getText().toString();
                ContentValues  values = new ContentValues();
                values.put(Constants.DB_BIRTHDAY,dateStr);
                values.put(Constants.DB_BIRTHDAY,dateStr);

                values.put(Constants.DB_NAME,nameStr);
                Uri uri = getContentResolver().insert(Constants.URI,values);
                Log.d("DB INSERT",uri.toString());
                break;
            case R.id.btnSelect:

                Cursor cursor = getContentResolver().query(Constants.URI,null,null,null,Constants.DB_ID);

                if (!cursor.moveToFirst()){
                    Log.d("DB SELCT", "Database is empty");
                }else{
                    do {
                        Log.d("Db Select", cursor.getString(cursor.getColumnIndex(Constants.DB_NAME)) + " " + cursor.getString(cursor.getColumnIndex(Constants.DB_BIRTHDAY)));
                    }while(cursor.moveToNext());
                }
                break;
        }

    }
}
