package com.homeassignment.listsdemo;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;

import com.homeassignment.listsdemo.models.User;

import java.util.ArrayList;

/**
 * Created by Bon on 5/28/2015.
 */
public class CustomUniAdapter extends BaseAdapter {

    ArrayList<User> users = new ArrayList<>();
    Context context;

    public CustomUniAdapter(Context context) {
        this.context = context;
        initializeUsers();
    }

    private void initializeUsers() {

        for (int i=0;i<10;i++){
           int getDrowableId = getDrawableByName("img_" +(i+1));
            User user = new User(i+1,"Pesho"+i ,"2",getDrowableId);
            users.add(user);
        }
    }


    @Override
    public int getCount() {
        return users.size();
    }

    @Override
    public User getItem(int position) {
        return users.get(position);
    }

    @Override
    public long getItemId(int position) {
        return getItem(position).getId();
    }

    private int getDrawableByName(String name){

        Resources resources = context.getResources();
        final int resourceId = resources.getIdentifier(name, "drawable",
                context.getPackageName());
        return  resourceId;
      //  return resources.getDrawable(resourceId);
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ImageView personImg;
        TextView name;
        TextView mark;


        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.uni_row, parent, false);
            name = (TextView) convertView.findViewById(R.id.name);
           personImg = (ImageView) convertView.findViewById(R.id.imageView);
            mark =  (TextView) convertView.findViewById(R.id.mark);

            //it works faster with set tag
            convertView.setTag(R.id.name, name);
            convertView.setTag(R.id.imageView, personImg);
            convertView.setTag(R.id.mark, mark);




        } else {
            name = (TextView) convertView.getTag(R.id.name);
            personImg = (ImageView) convertView.getTag(R.id.imageView);
            mark = (TextView) convertView.getTag(R.id.mark);

        }

        User e = getItem(position);

        name.setText("" + e.getName());
        mark.setText("" +e.getMark());
       personImg.setBackgroundResource(e.getImg());
      //  Picasso.with(context).load(e.getCoverSource()).into(eventPicture);

        return convertView;
    }
}
