package com.homeassignment.ticktacktoe;

import android.content.Intent;
import android.net.Uri;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;


public class MainActivity extends ActionBarActivity implements View.OnClickListener {

    Button btnStartGame;
    Button btnOpenSoftUni;
    EditText tbxName;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        btnStartGame = (Button) findViewById(R.id.btnStartGame);
        btnStartGame.setOnClickListener(this);

        btnOpenSoftUni = (Button) findViewById(R.id.btnOpenSoftUni);
        btnOpenSoftUni.setOnClickListener(this);

        tbxName = (EditText)findViewById(R.id.tbxName);

    }

    @Override
    protected void onStart() {
        super.onStart();

        Log.d(Constants.LOG_DEBUG, "onStart");
    }

    @Override
    protected void onResume() {
        super.onResume();
        Log.d(Constants.LOG_DEBUG, "onResume");
    }

    @Override
    protected void onPause() {
        super.onPause();
        Log.d(Constants.LOG_DEBUG, "onPause");
    }

    @Override
    protected void onStop() {
        super.onStop();
        Log.d(Constants.LOG_DEBUG, "onStop");
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        Log.d(Constants.LOG_DEBUG, "onDestroy");
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.btnStartGame:
                Intent intent = new Intent(this,TickTackToe.class);
                String name = String.valueOf(tbxName.getText()) ;
                intent.putExtra(Constants.INTENT_EXTRA,name);
                startActivity(intent);
                break;

            case R.id.btnOpenSoftUni:
                Intent openSoftUni = new Intent(Intent.ACTION_VIEW, Uri.parse("http://www.softuni.bg "));

                startActivity(openSoftUni);
                break;
        }
    }
}
