package com.homeassignment.ticktacktoe;

import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.ImageButton;
import android.widget.Toast;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;

/**
 * Created by Bon on 5/28/2015.
 */
public class MakeMoveAsync extends AsyncTask<String,Void,String> {

    Context context;
    ArrayList<ImageButton> allCells;

    public MakeMoveAsync(Context context, ArrayList<ImageButton> allCells) {
        this.context = context;
        this.allCells = allCells;
    }

    @Override
    protected String doInBackground(String... params) {

        String result="";
        String path = params[0];
        try {
            URL ulr = new URL(path);

            HttpClient defaultHttpClient = new DefaultHttpClient(new BasicHttpParams());
            HttpPost httpPost = new HttpPost(String.valueOf(ulr));
            HttpResponse response = defaultHttpClient.execute(httpPost);
            result = getStringByResponse(response);



        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return result;
    }
    private void makeToast(String message) {
        Toast toast = Toast.makeText(context,message,Toast.LENGTH_SHORT);
        toast.show();
    }

    @Override
    protected void onPostExecute(String result) {
        Log.d(Constants.LOG_DEBUG, result);

        try {
            JSONObject jsonObject = new JSONObject(result);
            JSONArray matrix = jsonObject.getJSONArray("Field");
            JSONArray firstRow = matrix.getJSONArray(0);
            JSONArray secondRow = matrix.getJSONArray(1);
            JSONArray thirdRow = matrix.getJSONArray(2);

            int col = 0;
            for (int i =0;i<allCells.size();i++){

                col =col%3;
                if (i<3){
                    setBtnByValue(firstRow, col, i);

                }else if(i<6){
                   setBtnByValue(secondRow, col, i);
                }else {
                    setBtnByValue(thirdRow, col, i);
                }

                col++;
            }

            boolean isEnd = jsonObject.getBoolean("IsEndGame");
            int winnerNumber = jsonObject.getInt("WinnerNumber");


            if (isEnd){
                if(winnerNumber==Constants.EMPTY_CELL_VALUE){
                    makeToast("Drow!");
                }else if(winnerNumber==Constants.COMPUTEL_CELL_VALUE){
                    makeToast("Sorry, you have lost!");
                }else if(winnerNumber==Constants.PLAYER_CELL_VALUE){
                    makeToast("BRAVO!");
                }

                Intent end = new Intent(context,TickTackToe.class);
                context.startActivity(end);
            }



        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    private void setBtnByValue(JSONArray firstRow, int col, int i) throws JSONException {
        int value = firstRow.getInt(col);
        ImageButton btn = allCells.get(i);
        if (value== Constants.COMPUTEL_CELL_VALUE){
            btn.setTag(Constants.COMPUTEL_CELL);
            btn.setBackgroundResource(R.drawable.computer_cell);
        }else if(value == Constants.PLAYER_CELL_VALUE){
            btn.setTag(Constants.PLAYER_CELL);
            btn.setBackgroundResource(R.drawable.player_cell);
        }
    }

    private String getStringByResponse(HttpResponse response) throws IOException {
        HttpEntity entity = response.getEntity();
        String resultString;
        InputStream inputStream = entity.getContent();
        InputStreamReader byteReader = new InputStreamReader(inputStream, "UTF-8");
        BufferedReader reader = new BufferedReader(byteReader, 8);
        StringBuilder sb = new StringBuilder();

        String line = null;
        while ((line = reader.readLine()) != null)
        {
            sb.append(line + "\n");
        }
        resultString = sb.toString();

        if(inputStream != null) {
            inputStream.close();
        }
        return resultString;
    }
}
