package com.homeassignment.ticktacktoe;

import android.content.Intent;
import android.net.Uri;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;


public class TickTackToe extends ActionBarActivity implements View.OnClickListener{

    ImageButton imageButton1;
    ImageButton imageButton2;
    ImageButton imageButton3;
    ImageButton imageButton4;
    ImageButton imageButton5;
    ImageButton imageButton6;
    ImageButton imageButton7;
    ImageButton imageButton8;
    ImageButton imageButton9;

    int[][] field = new int[3][3];

    ArrayList<ImageButton> allCells = new ArrayList<>();

    TextView lbName ;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tick_tack_toe);

        Intent intent = getIntent();
        String name = intent.getStringExtra(Constants.INTENT_EXTRA);

        lbName = (TextView) findViewById(R.id.lbName);
        lbName.setText(name);

        inititializeBtn();

    }

    private void inititializeBtn() {
        imageButton1 = (ImageButton) findViewById(R.id.imageButton1);
        imageButton1.setTag(Constants.EMPTY_CELL);
        imageButton1.setOnClickListener(this);
        allCells.add(imageButton1);

        imageButton2 = (ImageButton) findViewById(R.id.imageButton2);
        imageButton2.setTag(Constants.EMPTY_CELL);
        imageButton2.setOnClickListener(this);
        allCells.add(imageButton2);

        imageButton3 = (ImageButton) findViewById(R.id.imageButton3);
        imageButton3.setTag(Constants.EMPTY_CELL);
        imageButton3.setOnClickListener(this);
        allCells.add(imageButton3);

        imageButton4 = (ImageButton) findViewById(R.id.imageButton4);
        imageButton4.setTag(Constants.EMPTY_CELL);
        imageButton4.setOnClickListener(this);
        allCells.add(imageButton4);

        imageButton5 = (ImageButton) findViewById(R.id.imageButton5);
        imageButton5.setTag(Constants.EMPTY_CELL);
        imageButton5.setOnClickListener(this);
        allCells.add(imageButton5);

        imageButton6 = (ImageButton) findViewById(R.id.imageButton6);
        imageButton6.setTag(Constants.EMPTY_CELL);
        imageButton6.setOnClickListener(this);
        allCells.add(imageButton6);

        imageButton7 = (ImageButton) findViewById(R.id.imageButton7);
        imageButton7.setTag(Constants.EMPTY_CELL);
        imageButton7.setOnClickListener(this);
        allCells.add(imageButton7);

        imageButton8 = (ImageButton) findViewById(R.id.imageButton8);
        imageButton8.setTag(Constants.EMPTY_CELL);
        imageButton8.setOnClickListener(this);
        allCells.add(imageButton8);

        imageButton9 = (ImageButton) findViewById(R.id.imageButton9);
        imageButton9.setTag(Constants.EMPTY_CELL);
        imageButton9.setOnClickListener(this);
        allCells.add(imageButton9);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_tick_tack_toe, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.imageButton1:
makeToast("imageButton1");
                makeMove(imageButton1);
                break;

            case R.id.imageButton2:
                makeMove(imageButton2);
                break;

            case R.id.imageButton3:
                makeMove(imageButton3);
                break;

            case R.id.imageButton4:
                makeMove(imageButton4);
                break;

            case R.id.imageButton5:
                makeMove(imageButton5);
                break;

            case R.id.imageButton6:
                makeMove(imageButton6);
                break;
            case R.id.imageButton7:
                makeMove(imageButton7);
                break;

            case R.id.imageButton8:
                makeMove(imageButton8);
                break;

            case R.id.imageButton9:
                makeMove(imageButton9);
                break;


        }
    }

    private void makeMove(ImageButton btn) {

        String tag = String.valueOf(btn.getTag()) ;
        if(tag==Constants.EMPTY_CELL){
            btn.setTag(Constants.PLAYER_CELL);
            btn.setBackgroundResource(R.drawable.player_cell);

            setFieldByCellValues();

            String matrixAsString = getMatrixAsString();

            MakeMoveAsync move = new MakeMoveAsync(this,allCells);
            move.execute(Constants.SERVICE_URL+matrixAsString);

            Log.d(Constants.LOG_DEBUG,matrixAsString);

        }else {
            makeToast("The cell is full!");
        }

    }

    private void setFieldByCellValues() {

        int row = 0;
        int col =0;

        for (int i=0;i<allCells.size();i++){

           col = col%3;
            if(i!=0 && col ==0){
                row++;
            }

            int value = getValueByCell(allCells.get(i));
            field[row][col] = value;
            col++;
        }
    }

    private int getValueByCell(ImageButton btn) {
        int result = 0;
        String tag = String.valueOf(btn.getTag());
        if (tag==Constants.COMPUTEL_CELL){
            result = Constants.COMPUTEL_CELL_VALUE;
        }else if(tag == Constants.PLAYER_CELL){
            result = Constants.PLAYER_CELL_VALUE;
        }

        return  result;
    }

    private void makeToast(String message) {
        Toast toast = Toast.makeText(this,message,Toast.LENGTH_SHORT);
        toast.show();
    }

    public String getMatrixAsString() {
        String result = "";
        for (int row =0;row<field.length;row++){
            for (int col = 0;col<field[row].length;col++){
                result+=field[row][col] +",";
            }
        }

        return  result;
    }
}
